#include <stream.h>
#include <fstream.h>
#include <math.h>
#include <vector>
#include <string>

float cos_dist(vector<float> &x1, vector<float> &x2)
{
   double xx=0,xy=0,yy=0;
   for (int i=0;i<x1.size();i++)
   {
      //cerr << x1[i] << " " << x2[i] << endl;
      xx+=x1[i]*x1[i];
      xy+=x1[i]*x2[i];
      yy+=x2[i]*x2[i];
   }
   return xy/sqrt(xx*yy);
}

float cos_dist2(vector<float> &x1, vector<float> &x2)
{
   double xx=0,xy=0,yy=0;
   double sx=0,sy=0;
   for (int i=0;i<x1.size();i++)
   {
      sy+=x2[i];
      sx+=x1[i];
   }
   sx/=x1.size();
   sy/=x1.size();
   for (int i=0;i<x1.size();i++)
   {
      //cerr << x1[i] << " " << x2[i] << endl;
      xx+=(x1[i]-sx)*(x1[i]-sx);
      xy+=(x1[i]-sx)*(x2[i]-sy);
      yy+=(x2[i]-sy)*(x2[i]-sy);
   }
   return xy/sqrt(xx*yy);


}

float euc_dist(vector<float> &x1, vector<float> &x2)
{
   float sx=0,sy=0,d=0;
   for (int i=0;i<x1.size();i++)
   {
      sx+=x1[i];
      sy+=x2[i];
   }
   sx=1/sx;
   sy=1/sy;
   for (int i=0;i<x1.size();i++)
   {
      d+= (sx*x1[i]-sy*x2[i]) * (sx*x1[i]-sy*x2[i]);
   }
   return d;
}


float log_dist(vector<float> &x1, vector<float> &x2)
{
   float sx=0,sy=0,d=0;
   for (int i=0;i<x1.size();i++)
   {
      sy+=x2[i];
      sx+=x1[i];
   }
   sx=1/sx;
   sy=1/sy;
   for (int i=0;i<x1.size();i++)
   {
      d+=x2[i]*log(sx*(1+x1[i]));
   }
   return -d*sy-log(double(x1.size()));
}

int main(int argc, char **argv)
{
   ifstream f1(argv[1]);
   ifstream f2(argv[2]);

   string dummy;
   f1 >> dummy;
   f2 >> dummy;
   
   vector <float> x1;
   vector <float> x2;

   while (1)
   {
      float tmp;
      f1 >> tmp;
      if (!f1)
         break;
      x1.insert(x1.end(), tmp);
   }
   while (1)
   {
      float tmp;
      f2 >> tmp;
      if (!f2)
         break;
      x2.insert(x2.end(), tmp);
   }
   //cout << "xsize = " << x1.size() << " ysize = " << x2.size() << endl;
/*cerr << x1.size() << " "  << x2.size() << endl;*/
   cout << (1-cos_dist(x1,x2))*euc_dist(x1,x2)*1024 << " " << log_dist(x2,x1) << " " << log_dist(x1,x2)+log_dist(x2,x1) << " " 
        << cos_dist2(x1,x2) << " " << cos_dist(x1,x2) << " " << x2.size() << endl;
}
