#ifndef UINODE_H
#define UINODE_H

//#include <gnome.h>
#include <string>
#include <vector>
#include <string>
#include <tree.h>
#include <fstream.h>

#include "UINetTerminal.h"

class UINetwork;
class GUINetwork;
class UINodeParameters;
class UILink;

class UINetTerminal;
class UITerminal;

class Node;
class ParameterSet;

class UINode {
protected:
   bool destroyed;
   string name;

   UINetwork *net;


   string type;

   double x,y;

   double xtmp,ytmp;

   vector <UITerminal *> inputs;

   vector <UITerminal *> outputs;

   UINodeParameters *parameters;

public:

   UINode(UINetwork* _net, string _name, string _type, double x, double y, bool doInit=1);

   UINode(UINetwork* _net, xmlNodePtr def, bool doInit=1);

   virtual ~UINode();


   const string &getName() {return name;}

   UINetwork * getNetwork() {return net;}

   void saveXML(xmlNode *root);

   UITerminal *getInputNamed(string n);

   UITerminal *getOutputNamed(string n);

   void getPos (double &xx, double &yy)
   {
      xx=x;
      yy=y;
   }

   void export2net (ostream &out);
/*
   virtual void setAsCondition();
   
   virtual void unsetAsCondition();
*/   
   void insertNetParams(vector<string> &params);

   virtual UITerminal *newTerminal (string _name, UINode *_node, bool _isInput, double _x, double _y);

   virtual UILink *newLink (UITerminal *_from, UITerminal *_to);

   virtual UINetTerminal *newNetTerminal (UITerminal *_terminal, UINetTerminal::NetTermType _type, string _name);

   virtual UINodeParameters *newNodeParameters (UINode *_node, string type);

   Node *build(const ParameterSet &params);

   friend UINetwork;
   friend GUINetwork;
};


#endif
