#ifndef UINODEPARAMETERS_H
#define UINODEPARAMETERS_H

#include <gnome.h>
#include <string>
#include <vector>
#include <tree.h>

class UINode;
class ParameterSet;

class ParameterData {
public:
   string name;
   string value;
   string type;
   
   GtkWidget *optionmenu;
   GtkWidget *optionmenu_menu;
   GtkWidget *combo_entry;
   GtkWidget *entry;
   GtkWidget *label;

};

class UINodeParameters {
protected:
   vector<ParameterData> params;
   UINode *node;
public:
   UINodeParameters(UINode *_node, string type);
   virtual ~UINodeParameters();
   void saveXML(xmlNode *root);
   void export2net(ostream &out);
   void load(xmlNodePtr node);
   ParameterData *getParamNamed(string n);
   const vector<string> &allTypes();
   void insertNetParams(vector<string> &par);
   virtual void insertLoadedParam(ParameterData *param, string type, string value);
   ParameterSet *build(const ParameterSet &par);
};


#endif
